
{ ------------------------------------   COMMENTAIRES SUR LA METHODE  ----------------------------------------------

  Donnes fournies  :
  	Date de tir 
        Date du tremplin terre (  choisir autour du 15 janvier 2001)
        Date de survol de la comte Wild2 (impose)
        NB : Les heures sont pour la plupart fixes  12 h

        Les conditions de tir pour la vitesse infinie (dclinaison, lvation, C3)
         
 CALCUL 1:  PROCEDURE ORBITE0_AVANT_CORRECTION ===> Les paramtres de l'orbite 0 aprs la sortie sphre (en tenant
        compte du rayon de la sphre et du temps de traverse.

 CALCUL 2:   PROCEDURE OPTIMISATION_CORRECTION; ===> La correction de trajectoire intermdiaire ( La NASA annonce
        environ 160 m/s ) qui permet de rejoindre la Terre   la date du tremplin le 15/1/2001
        Ce calcul est excut  avec l'hypothse des sphres d'influence la plus simple.
        * L'optimisation porte sur la date qui permet un DV minimal

 CALCUL 3 : PROCEDURE ORBITE_AVANT_TREMPLIN, elle donne les paramtres orbitaux de l'orbite aprs correction,
        et permettra donc le calcul de la vitesse infinie d'entre dans la sphre d'influence de la Terre.

 CALCUL 4 :PROCEDURE VITESSE_INFINIE_ARRIVEE

 CALCUL 5 : PROCEDURE LAMBERT_INTERMEDIAIRE l'auteur a excut cette routine pour vous, qui permet de calculer
        la trajectoire de LAMBERT joignant la Terre  la comte , mais c'est rare, A PLUS D'UN TOUR, ce qui donne
        2 orbites possibles que le programme aurait du mal  choisir.

 CALCUL 6 : PROCEDURE ITERATION_SUR_PSI qui effectue un balayage sur toutes les hyperboles de survol  prige fix
        ce qui autorise le meilleur des conditions de sortie de sphre d'influence, pour minimiser la correction de
        sortie de Tremplin.

 CALCUL 7 :PROCEDURE VITESSE_INFINIE_SORTIE_TREMPLIN

 CALCUL 8 : PROCEDURE ALTITUDE_SURVOL_OPTIMAL elle ralise un balayage des altitudes de survol pour obtenir l'altitude
        optimale qui donne le minimum minimorum de la correction finale

---------------------------------------------------------------------------------------------------------------------}

PROGRAM STARDUST;

uses constype,fonscal,wincrt,fonvect,inj_heli,dates,RVPARAM,PARAMRV,
     TERRE,BIPOSE,BIPOS;

 var vitesse_helio0,rayon_helio0,rayon_helio1,vitesse_helio1,rayon_helio_correction,vitesse_helio_correction:vecteur;
     declinaison,ascension_droite,C3,mu,rayon_sphere,date_calcul_correction:real;
     datetir0,heuretir0,datetir,heuretir,date_survol_tremplin_terre,heure_survol_terre:string;
     ch:char;
     param0,param1:tabparam;
     vitarrivee,vitesse_helio_terre1,vit_infinie_arrivee_terre,Vitesse_helio_arrivee,Vit_inf_sortie_min:vecteur;
     C3_T_ARRIVEE,altitude_survol_tremplin,psi:real;
     date_entree,heure_entree:string;
     vit_infinie_sortie,Vitesse_helio_depart,rayon_comete,vit_helio_depart,vit_helio_arrivee_comete:vecteur;
     vitesse_helio_sortie,DeltaV_MIN_CORRECTION,DV_OPTIMAL:vecteur;
     Dv_min,DVMIN_MIN,Altitude_optimale,PSIMIN_MIN,PSI_MIN:real;
     i:integer;
     autorisation_ecriture:boolean;
     iteration,choix:integer;
     increment_min:real;
     {------------------------------------------------------------------------------------}
     PROCEDURE ATTENTE_ECRAN;

     BEGIN
        If (5-iteration)>1 then
          begin
           WriteLn;WriteLn;WriteLn;WriteLn;WriteLn;WriteLn;WriteLn;WriteLn;WriteLn;
            WriteLn('     ',4-iteration,' ITERATION(S) A VENIR....,!!!! PATIENTEZ...et....APPUYEZ POUR CONTINUER');
            ch:=readkey;
         end;
        If (5-iteration)=1 then writeLn('     ITERATIONS TERMINEES.... et....APPUYEZ POUR CONTINUER');
      END;

     {------------------------------------------------------------------------------------}


  FUNCTION ANGLE_TERRE_SOLEIL_SONDE(date,heure:string;rayon_sonde:vecteur):real;   { Sortie en radian }
   Var date_jour,date_heure:string;
       paramT:tabparam;
       rayon_terre,vitesse_terre:vecteur;
  BEGIN

     date_jour:=date;
     date_heure:=heure;
     ephemterre(date_jour,date_heure,mus,0,paramT,rayon_terre,vitesse_terre);

     ANGLE_TERRE_SOLEIL_SONDE:=ANGVECT(rayon_terre,rayon_sonde);


  END;

 { ------------------------------------------------------------------------------------------------------}

 PROCEDURE DATE_ENTREE_SPHERE(date_survol_tremplin_terre,heure_survol_terre:string;Var date_entree,heure_entree:string);


 Var traversee,JJdateTir0,JJdateTir:real;


 BEGIN

 traversee:=Rayon_sphere/sqrt(C3_T_ARRIVEE);

 JJdateTir0:=JourJulien(date_survol_tremplin_terre,heure_survol_terre);  { Date julienne du survol hyperbolique }
 JJdateTir:=JJdatetir0-Traversee/86400;       { Date julienne d'entre d'influence}

 Date_entree:=DateSimple(JJdateTir);               { Date 'STRING' d'entre sphre d'influence}
 Heure_Entree:=HeureSimple(JJdateTir);             { Heure 'STRING' d'entre sphre d'influence}


 END;

{------------------------------------------------------------------------------------}

PROCEDURE DONNEES_MISSION(Var choix:integer);

Var k:real;
    ch:char;


BEGIN

  k:=pi/180;
  Rayon_sphere:=880000;
  Mu:=Mus;

  { ************** Donnes en degrs converties en radian. Source: NASA - JPL **********************}
  WRITELN('        **********************************************************');
  WRITELN;
  WRITELN('                       MISSION STARDUST');
  WriteLn('      DE RECUEIL DE POUSSIERES COMETAIRES ET RETOUR SUR TERRE');
  WriteLn;
   WRITELN('     **********************************************************');
  WRITELN;
  WriteLn('     Adoptons comme la NASA le tir nominal du 6 fvrier 1999:');
  WriteLn;
  WRITELN('     **********************************************************');
  WRITELN;
  {******WriteLn('      Choix 1 : 6 fvrier 1999  & Tremplin Terre le 15 janvier 2001 ---> Tapez 1');
  WriteLn('      Choix 2 : 12 fvrier 1999 & Tremplin date voisine du 15/1/2001---> Tapez 2');
  WriteLn('      Choix 3 : 6 fvrier 1999  & Tremplin date voisine du 15/1/2001---> Tapez 3 ');
  WriteLn;******* }
  WRITELN('     **********************************************************');
  WRITELN('     Pour l''altitude un balayage final permettra le choix optimal');
  WriteLn('     indpendamment du choix que vous pouvez faire sur la demande');
  WriteLn;
  Choix:=1;

  Case CHOIX of
   1:Begin
         declinaison:=-19.5*k;ascension_droite:=234.62*k;datetir0:='06021999'; Heuretir0:='120000';
         date_survol_tremplin_terre:='15012001';
     End;
   2:Begin
         declinaison:=-20.69*k;ascension_droite:=240.69*k;datetir0:='12021999'; Heuretir0:='120000';
         WriteLn;
  	 WriteLn('     CHOIX DE LA DATE DU TREMPLIN SUR LA TERRE NB: nous gardons l''heure  12 h');
  	 WriteLn('          **     LA NASA avait prvu autour du 15/01/2001    ***');
         WriteLn;
  	 Write('    Choix 5 au 25 janvier avec date donne sous la forme: 06012001 ? :');ReadLn(date_survol_tremplin_terre);
       	 heure_survol_terre:='120000';
      end;
   3:Begin
         declinaison:=-19.5*k;ascension_droite:=234.62*k;datetir0:='06021999'; Heuretir0:='120000';
         WriteLn;
  	 WriteLn('     CHOIX DE LA DATE DU TREMPLIN SUR LA TERRE NB: nous gardons l''heure  12 h');
  	 WriteLn('          **     LA NASA avait prvu autour du 15/01/2001    ***');
         WriteLn;
  	 Write('    Choix 5 au 25 janvier avec date donne sous la forme: 06012001 ? :');ReadLn(date_survol_tremplin_terre);
       	 heure_survol_terre:='120000';
     End;

  End; {Case}

  C3:=26;                         { En km/s}

  { ********************  Date de survol de la Terre pour le tremplin ***********************}

  WriteLn;
  WriteLn('     CHOIX DE L''ALTITUDE DE SURVOL LORS DU TREMPLIN SUR LA TERRE ');
  WriteLn('          **     LA NASA AVAIT PREVU 6000 KM    ***');
  WriteLn;
  Write('     Donnez votre choix entre 2000 et 20000 km ---> ALTITUDE EN KM ? :');ReadLn(altitude_survol_tremplin);

  clrscr;

  {--------------  ECRITURE DES DONNEES INITIALES --------------------}

  WriteLn;
  WriteLn('     *************** MISSION STAR DUST ( NASA - JPL ) ***************');WriteLn;
  WriteLn('     CONDITIONS DU TIR HYPERBOLIQUE TERRESTRE LE ',datetir0,'  ',heuretir0);
  WriteLn;
  WriteLn('          Dclinaison      = ',(declinaison*180/pi):8:3,' degrs');
  WriteLn('          Ascension droite = ',(ascension_droite*180/pi):8:3,' degrs');
  WriteLn('          Constante C3     = ',C3:7:3,' km/s2');
  WriteLn;
  WriteLn;

  { --------------------------------------------------------------------------------------}

  { EPHEMERIDES COMETE WILD-2 LE 2/1/2004 12 h 00 00}

  rayon_comete[1]:=-171.47365e6;
  rayon_comete[2]:=-218.18235e6;
  rayon_comete[3]:=15.63268e6;


END;

{------------------------------------------------------------------------------------}

 PROCEDURE DATE_SORTIE_SPHERE(datetir0,heuretir0:string;Var datetir,heuretir:string);


 Var traversee,JJdateTir0,JJdateTir:real;


 BEGIN

 traversee:=Rayon_sphere/sqrt(C3);

 JJdateTir0:=JourJulien(datetir0,heuretir0);  { Date julienne du tir  l'injection hyperbolique }
 JJdateTir:=JJdatetir0+Traversee/86400;       { Date julienne de sortie sphre d'influence}

 Datetir:=DateSimple(JJdateTir);               { Date 'STRING' de sortie sphre d'influence}
 HeureTir:=HeureSimple(JJdateTir);             { Heure 'STRING' de sortie sphre d'influence}


 END;

{------------------------------------------------------------------------------------}

 PROCEDURE ORBITE0_AVANT_CORRECTION;

 Var ch:char;

 BEGIN
  { ********* Calcul de la position et vitesse hliocentrique au sortir sphre influence Terre ********* }

  VITESSE_INFINIE_TERREtoVITESSE_HELIO(declinaison,ascension_droite,C3,Rayon_sphere,Mu,
                                 datetir0,heuretir0,vitesse_helio0,rayon_helio0);

  {************* Calcul de la date d'injection hliocentrique hors sphre influence **************}

  DATE_SORTIE_SPHERE(datetir0,heuretir0,datetir,heuretir);  { Donnent les 'string' pour date et heure}


  {************* Calcul des paramtres orbitaux de la premire orbite **************}

  POSVITPARAM(rayon_helio0,vitesse_helio0,datetir,heuretir,mu,param0);

  WriteLn;

  { ----------------------  ECRITURE DES CALCULS INTERMEDIAIRES -----------------------}
   clrscr;
   WriteLn('     EPHEMERIDES DE LA SONDE A L''INJECTION HELIOCENTRIQUE LE ',datetir,'  ',heuretir);
   WriteLn;
   WriteLn('               X= ',(rayon_helio0[1]/1e6):9:4,' e6  km');
   WriteLn('               Y= ',(rayon_helio0[2]/1e6):9:4,' e6  km');
   WriteLn('               Z= ',(rayon_helio0[3]/1e6):9:4,' e6  km');WriteLn;

   WriteLn('               Vx= ',vitesse_helio0[1]:8:3,' km/s');
   WriteLn('               Vy= ',vitesse_helio0[2]:8:3,' km/s');
   WriteLn('               Vz= ',vitesse_helio0[3]:8:3,' km/s');WriteLn;


   WriteLn('     PARAMETRES ORBITAUX HELIOCENTRIQUES AVANT CORRECTION HELIOCENTRIQUE');
   WriteLn;
   WriteLn('               a  = ',(param0[1]/1e6):9:4,' e6  km');
   WriteLn('               e  = ',param0[2]:7:6);
   WriteLn('               i  = ',(param0[3]*180/pi):7:3,' degrs');
   WriteLn('               w  = ',(param0[4]*180/pi):7:3,' degrs');
   WriteLn('               W  = ',(param0[5]*180/pi):7:3,' degrs');
   WriteLn('               phi= ',(param0[6]*180/pi):7:3,' degrs');
   WriteLn('               Tp = ', param0[7]:10:5,' Jours Juliens');WriteLn;

   WriteLn(' ???? Notez vos rsultats avant de passer  la suite, puis appuyez une touche');
   WriteLn;
   WriteLn('    PATIENTEZ LES CALCULS ITERATIFS SONT LONGS !!! ......APPUYEZ UNE TOUCHE');
   ch:=readkey; clrscr;
   ATTENTE_ECRAN;

 END;

 {------------------------------------------------------------------------------------}

  PROCEDURE OPTIMISATION_CORRECTION;

  { *******************************************************************************************
    *Elle consiste, sur la premire orbite  dterminer le point et la date 1 o la correction*
    *de trajectoire qui fait passer de ce point  la Terre  la date 2, pour un tremplin est  *
    *optimale( MINIMISATION DU DV )                                                           *
    *******************************************************************************************}


  VAR periode0,intervalle,duree,duree_apres_correction,align,align_correction:real;
      date_calcul,temps_debut,temps_fin,angle_phi:real;
      param0_modifie,paramT,parametres:tabparam;
      p,q,w,r,v,rd,ra,vitdepart,rayon_helio_terre1:vecteur;
      i,imprim,cas:integer;
      result,DeltaVitesse,rayon_helio1,vitesse_helio1:vecteur;
      deltaV,DeltaV_ancien,Phi_correction:real;
      Date_correction,datedepart,heuredepart,date,heure:string;
      bool:boolean;
  BEGIN

   { BALAYAGE DES POSITIONS ET CALCUL DE DV 180 jours aprs le prige et 30 avant le suivant
   }
  periode0:=2*pi*(param0[1]*sqrt(param0[1]/mus))/86400; { Priode 0 en jours dcimaux}
  intervalle:=2;  { jours }
  temps_debut:= param0[7]+280;temps_debut:=Int(temps_debut/intervalle)*intervalle;    { Calcul en jours JJ}
  temps_fin:=param0[7]+periode0-30;temps_fin:= Int(temps_fin/intervalle)*intervalle;  { Calcul en jours JJ}


  { ---- Calcul de la position terre  la date du tremplin }

  ephemterre(date_survol_tremplin_terre,heure_survol_terre,mus,0,paramT,rayon_helio_terre1,vitesse_helio_terre1);

  { ------------ }

  date_calcul:=temps_debut; { Initialisation de la boucle }
  DeltaV_ancien:=10000;
  duree_apres_correction:=0;

  while date_calcul<=temps_fin  do
      BEGIN
         {--- Calcul de la position-vitesse  le long de l'orbite,  intervalles rguliers }
         angle_phi:=0;
         for i:=1 to 10 do
            begin
             angle_phi:=param0[2]*sin(angle_phi)+2*pi/periode0*(date_calcul-param0[7]); { Anomalie excentrique en rd }
            end;

         param0_modifie:=param0;
         param0_modifie[6]:=angle_phi;
         posvitperifocal(mus,param0_modifie,p,q,w,rayon_helio1,vitesse_helio1);

         { ------  Calcul du vol de Lambert entre les 2 points -------}

         duree:=JourJulien(date_survol_tremplin_terre,heure_survol_terre)-date_calcul;

         Rd[1]:=rayon_helio1[1];
         Rd[2]:=rayon_helio1[2];
         Rd[3]:=rayon_helio1[3];

         Ra[1]:=rayon_helio_terre1[1];
	 Ra[2]:=rayon_helio_terre1[2];
	 Ra[3]:=rayon_helio_terre1[3];

         cas:=1;

         ELLIPSE2POINTS(Rd,Ra,duree,mus,cas,vitdepart,vitarrivee);

         { ---------------- Calcul de l'incrment de vitesse et de son minimum ----------
                       En vrifiant que l'angle Terre Soleil Sonde est <>3 ou < 177 }

         Scalvect(-1,vitesse_helio1,result);
         SOMME(result,vitdepart,DeltaVitesse);

         DeltaV:=norm(DeltaVitesse);
         date:=DateSimple(date_calcul);
         heure:=HeureSimple(date_calcul);
         Align:=ANGLE_TERRE_SOLEIL_SONDE(date,heure,rayon_helio1)*180/pi;

         bool:= (DeltaV<=DeltaV_ancien) and ((align>3) and(align<177));

         if bool then

          BEGIN

              DeltaV_ancien:=DeltaV;
              Date_correction:=DateNormale(date_calcul); { Date_calcul EN JOURS JULIENS et date_correction calendaire }
              Phi_correction:=Angle_Phi;
              duree_apres_correction:=duree;
              align_correction:=align;
              date_calcul_correction:=date_calcul;
              rayon_helio_correction:=rayon_helio1;
              vitesse_helio_correction:=vitdepart;
              Vitesse_helio_arrivee:=vitarrivee;

          END;

         { -------- Incrementation de la date pour la boucle ---------}

        date_calcul:=date_calcul+intervalle;


      END;


   { ECRITURES DES RESULTATS HORS DE LA BOUCLE } 

   WriteLn;
   WriteLn(' ********** PREMIER CALCUL EN SPHERE D''INFLUENCE SIMPLIFIEE ***********');
   WriteLn('     Il s''agit de calculer la position et la correction optimale qui');
   WriteLn('     permettent de  de rejoindrela terre pour le tremplin de janvier 2001');
   WriteLn;
   WriteLn('     PERIODE AVANT CORRECTION = ',periode0:8:3,' Jours');
   WriteLn('     DUREE DU VOYAGE RESTANT APRES CORRECTION = ',duree_apres_correction :8:3);
   WriteLn('     EPHEMERIDES DE LA TERRE LORS DU TREMPLIN LE ',date_survol_tremplin_terre);
   WriteLn;
   WriteLn('               X= ',(rayon_helio_terre1[1]/1e6):9:4,' e6  km');
   WriteLn('               Y= ',(rayon_helio_terre1[2]/1e6):9:4,' e6  km');
   WriteLn('               Z= ',(rayon_helio_terre1[3]/1e6):9:4,' e6  km');WriteLn;

   WriteLn('               Vx= ',vitesse_helio_terre1[1]:8:3,' km/s');
   WriteLn('               Vy= ',vitesse_helio_terre1[2]:8:3,' km/s');
   WriteLn('               Vz= ',vitesse_helio_terre1[3]:8:3,' km/s');WriteLn;

   WriteLn('     Minimum correction DV =',(DeltaV_ancien*1000):7:2,' m/s','  la date : ',Date_correction);
   WriteLn('     Correction au point d''anomalie excentrique PHI = ',(Phi_correction*180/pi):7:2,' degrs');
   WriteLn;
   WriteLn('     Angle Terre-Soleil-Sonde gal  :',align_correction:6:2,' degrs'); WriteLn;
   WriteLn(' ???? Notez vos rsultats avant de passer  la suite, puis appuyez une touche');ch:=readkey;


END;

 { ------------------------------------------------------------------------------------------------------}

 PROCEDURE ORBITE_AVANT_TREMPLIN(R,V:vecteur;DATE:real;PARAM1:tabparam);


 Var periode1:real;

 BEGIN

    datetir:=DateSimple(Date_Calcul_Correction);
    Heuretir:=HeureSimple(Date_Calcul_Correction);
    POSVITPARAM(R,V,datetir,heuretir,mus,param1);

    periode1:=2*pi*(param1[1]*sqrt(param1[1]/mus))/86400; { Priode 1 en jours dcimaux}
 If autorisation_ecriture then
  BEGIN
    WriteLn;
    WriteLn('     PARAMETRES ORBITAUX APRES CORRECTION HELIOCENTRIQUE');
    WriteLn;
    WriteLn('               a  = ',(param1[1]/1e6):9:4,' e6  km');
    WriteLn('               e  = ',param1[2]:7:6);
    WriteLn('               i  = ',(param1[3]*180/pi):7:3,' degrs');
    WriteLn('               w  = ',(param1[4]*180/pi):7:3,' degrs');
    WriteLn('               W  = ',(param1[5]*180/pi):7:3,' degrs');
    WriteLn('               phi= ',(param1[6]*180/pi):7:3,' degrs');
    WriteLn('               Tp = ', param1[7]:10:5,' Date au prige en jours Juliens');WriteLn;

    WriteLn('      Nouvelle priode : T1 = ',periode1:8:4,' jours'); WriteLn;
    WriteLn(' ???? Notez vos rsultats avant de passer  la suite, puis appuyez une touche');
    ch:=readkey;

  END;
 END;

   { ------------------------------------------------------------------------------------------------------}
    PROCEDURE VITESSE_INFINIE_ARRIVEE(Param1:tabparam;date_survol_tremplin_terre,heure_survol_terre:string;
                 Var vit_infinie_arrivee_terre:vecteur;Var C3_T_ARRIVEE:real);
       Var result:vecteur;

     BEGIN

          Scalvect(-1,vitesse_helio_terre1,result);
          Somme(result,Vitesse_helio_arrivee,vit_infinie_arrivee_terre);
          C3_T_ARRIVEE:=Puiss(norm(vit_infinie_arrivee_terre),2);

       if autorisation_ecriture then
         begin
          WriteLn;
          WriteLn('     **************** ETUDE DU TREMPLIN SUR LA TERRE *******************');WriteLn;
          WriteLn('     Date '); WriteLn;

          WriteLn('     VITESSE HELIOCENTRIQUE D''ARRIVEE :');
          WriteLn('               Vx= ',Vitesse_helio_arrivee[1]:8:3,' km/s');
          WriteLn('               Vy= ',Vitesse_helio_arrivee[2]:8:3,' km/s');
          WriteLn('               Vz= ',Vitesse_helio_arrivee[3]:8:3,' km/s');WriteLn;

          WriteLn('     VITESSE HELIOCENTRIQUE DE  LA TERRE :');
          WriteLn('               Vx= ',vitesse_helio_terre1[1]:8:3,' km/s');
          WriteLn('               Vy= ',vitesse_helio_terre1[2]:8:3,' km/s');
          WriteLn('               Vz= ',vitesse_helio_terre1[3]:8:3,' km/s');WriteLn;

          WriteLn('     VITESSE INFINIE D''ARRIVEE :');
          WriteLn('               Vinfx= ',vit_infinie_arrivee_terre[1]:8:3,' km/s');
          WriteLn('               Vinfy= ',vit_infinie_arrivee_terre[2]:8:3,' km/s');
          WriteLn('               Vinfz= ',vit_infinie_arrivee_terre[3]:8:3,' km/s');WriteLn;

          WriteLn('     Constante C3 du tremplin C3 = ',C3_T_ARRIVEE,' km/s');

         end;

     END;

   { ------------------------------------------------------------------------------------------------------}

   PROCEDURE OPTIMISATION_CORRECTION_NOUVELLE(var increment_min:real);

  { *********************************************************************************************
    * Elle consiste, sur la premire orbite  dterminer le point et la date 1 o la correction *
    * de trajectoire qui fait passer de ce point  la Terre  la date 2, pour un tremplin est   *
    * optimale( MINIMISATION DU DV )                                                            *
    *********************************************************************************************}


  VAR periode0,intervalle,duree,duree_apres_correction,align,align_correction:real;
      date_calcul,temps_debut,temps_fin,angle_phi:real;
      param0_modifie,paramT,parametres:tabparam;
      p,q,w,r,v,rd,ra,vitdepart,rayon_helio_terre1:vecteur;
      i,imprim,cas:integer;
      result,DeltaVitesse,rayon_helio1,vitesse_helio1:vecteur;
      deltaV,DeltaV_ancien,Phi_correction:real;
      Date_correction,datedepart,heuredepart,date,heure:string;
      bool:boolean;
      rayon_helio_entree,vitesse_helio_entree,vinf_unit:vecteur;

  BEGIN

   { BALAYAGE DES POSITIONS ET CALCUL DE DV 180, jours aprs le prige et 30 avant le suivant }

  periode0:=2*pi*(param0[1]*sqrt(param0[1]/mus))/86400; { Priode 0 en jours dcimaux}
  intervalle:=2;  { jours }
  temps_debut:= param0[7]+280;temps_debut:=Int(temps_debut/intervalle)*intervalle;    { Calcul en jours JJ}
  temps_fin:=param0[7]+periode0-150;temps_fin:= Int(temps_fin/intervalle)*intervalle;  { Calcul en jours JJ}

  { --------------------- CONDITIONS DE RENTREE SPHERE TERRE --------------------}

  DATE_ENTREE_SPHERE(date_survol_tremplin_terre,heure_survol_terre,date_entree,heure_entree);

  { ---- Calcul de la position terre  la date du tremplin qui n'a pas chang}

  ephemterre(date_entree,heure_entree,mus,0,paramT,rayon_helio_entree,vitesse_helio_entree);

  Scalvect(-rayon_sphere/norm(vit_infinie_arrivee_terre),vit_infinie_arrivee_terre,result);
  Somme(result,rayon_helio_entree,rayon_helio_entree);

  { ------------ }

  date_calcul:=temps_debut; { Initialisation de la boucle }
  DeltaV_ancien:=10000;
  duree_apres_correction:=0;

  while date_calcul<=temps_fin  do
      BEGIN
         {--- Calcul de la position-vitesse  le long de l'orbite,  intervalles rguliers }
         angle_phi:=0;
         for i:=1 to 10 do
            begin
             angle_phi:=param0[2]*sin(angle_phi)+2*pi/periode0*(date_calcul-param0[7]); { Anomalie excentrique en rd }
            end;

         param0_modifie:=param0;
         param0_modifie[6]:=angle_phi;
         posvitperifocal(mus,param0_modifie,p,q,w,rayon_helio1,vitesse_helio1);

         { ------  Calcul du vol de Lambert entre les 2 points -------}

         duree:=JourJulien(date_entree,heure_entree)-date_calcul;

         Rd[1]:=rayon_helio1[1];
         Rd[2]:=rayon_helio1[2];
         Rd[3]:=rayon_helio1[3];

         unitaire(vit_infinie_arrivee_terre,vinf_unit);

         scalvect(rayon_sphere,vinf_unit,result);

         Ra[1]:=rayon_helio_entree[1]-result[1];
	 Ra[2]:=rayon_helio_entree[2]-result[2];
	 Ra[3]:=rayon_helio_entree[3]-result[3];

         cas:=1;

         ELLIPSE2POINTS(Rd,Ra,duree,mus,cas,vitdepart,vitarrivee);

         { ---------------- Calcul de l'incrment de vitesse et de son minimum ----------
                       En vrifiant que l'angle Terre Soleil Sonde est <>3 ou < 177 }

         Scalvect(-1,vitesse_helio1,result);
         SOMME(result,vitdepart,DeltaVitesse);

         DeltaV:=norm(DeltaVitesse);
         date:=DateSimple(date_calcul);
         heure:=HeureSimple(date_calcul);
         Align:=ANGLE_TERRE_SOLEIL_SONDE(date,heure,rayon_helio1)*180/pi;

         bool:= (DeltaV<=DeltaV_ancien) and ((align>3) and(align<177));

         if bool then

          BEGIN

              DeltaV_ancien:=DeltaV;
              Date_correction:=DateNormale(date_calcul); { Date_calcul EN JOURS JULIENS et date_correction calendaire }
              Phi_correction:=Angle_Phi;
              duree_apres_correction:=duree;
              align_correction:=align;
              date_calcul_correction:=date_calcul;
              rayon_helio_correction:=rayon_helio1;
              vitesse_helio_correction:=vitdepart;
              Vitesse_helio_arrivee:=vitarrivee;
              increment_min:=deltaV;
          END;

         { -------- Incrementation de la date pour la boucle ---------}

        date_calcul:=date_calcul+intervalle;


      END;

 If autorisation_ecriture then
  BEGIN

   { ECRITURES DES RESULTATS HORS DE LA BOUCLE sur autorisation }

   WriteLn;
   WriteLn(' ****************** RESULTATS:DEUXIEME ITERATION DU SURVOL ***********************');
   WriteLn;
   WriteLn('     Suite plus fine du calcul de la position et la correction optimale qui');
   WriteLn('     permettent de  de rejoindrela terre pour le tremplin de janvier 2001');
   WriteLn('     Mais en tenant compte DU POINT DE SORTIE SUR LA SPHERE D''INFLUENCE');
   WriteLn;
   WriteLn('     PERIODE AVANT CORRECTION = ',periode0:8:3,' Jours');
   WriteLn('     DUREE DU VOYAGE RESTANT APRES CORRECTION = ',duree_apres_correction :8:3,' jours');
   WriteLn('     EPHEMERIDES DE LA TERRE LORS DU TREMPLIN LE ',date_survol_tremplin_terre);
   WriteLn('               X= ',(rayon_helio_terre1[1]/1e6):9:4,' e6  km');
   WriteLn('               Y= ',(rayon_helio_terre1[2]/1e6):9:4,' e6  km');
   WriteLn('               Z= ',(rayon_helio_terre1[3]/1e6):9:4,' e6  km');WriteLn;

   WriteLn('               Vx= ',vitesse_helio_terre1[1]:8:3,' km/s');
   WriteLn('               Vy= ',vitesse_helio_terre1[2]:8:3,' km/s');
   WriteLn('               Vz= ',vitesse_helio_terre1[3]:8:3,' km/s');WriteLn;

   WriteLn('     Minimum correction DV =',(DeltaV_ancien*1000):7:2,' m/s','  la date : ',Date_correction);
   WriteLn('     Correction au point d''anomalie excentrique PHI = ',(Phi_correction*180/pi):7:2,' degrs');
   WriteLn;
   WriteLn('     Angle Terre-Soleil-Sonde gal  :',align_correction:6:2,' degrs'); WriteLn;
   WriteLn(' ???? Notez vos rsultats avant de passer  la suite, puis appuyez une touche');ch:=readkey;
  END;

  ATTENTE_ECRAN;

END;

{ --------------------------------------------------------------------------------------------------------}

PROCEDURE VITESSE_INFINIE_SORTIE_TREMPLIN(psi,altitude_survol_tremplin:real;vit_infinie_arrivee_terre:vecteur;
                                          Var vit_infinie_sortie:vecteur);

Var U,V,D_inf,result1,result2,result3,Z:vecteur;
    exc,D,phi_asymptote,A,rayon_perigee,verif:real;
    ch :char;

  BEGIN


  { Calcul du vecteur unitaire U }

  SCALVECT(-1/norm(vit_infinie_arrivee_terre),vit_infinie_arrivee_terre,U);

  { CALCUL DE D infinie et angle phi}

  A:=mut/Prodscal(vit_infinie_arrivee_terre,vit_infinie_arrivee_terre);
  rayon_perigee:=altitude_survol_tremplin+6378;
  exc:=1+rayon_perigee/A;
  phi_asymptote:=Arccos(1/exc);
  D:=A*tan(phi_asymptote);

  Z[1]:=0; Z[2]:=0;Z[3]:=1;

  Scalvect(D*cos(psi),Z,result1);
  Prodvect(U,Z,result2);
  Scalvect(D*sin(psi),result2,result3);

  Somme(result1,result3,D_inf);

  { Calcul de l'unitaire V }

  SCALVECT(1/norm(D_inf),D_inf,V);

  { Calcul vitesse infinie sortie }

  scalvect(cos(2*phi_asymptote),U,result1);
  scalvect(-sin(2*phi_asymptote),V,result2);

  Somme(result1,result2,result3);
  scalvect(norm(vit_infinie_arrivee_terre),result3,vit_infinie_sortie);

 END;

{ --------------------------------------------------------------------------------------------------------}
    PROCEDURE LAMBERT_INTERMEDIAIRE(var vitesse_helio_depart:vecteur);

    Var date_sortie,heure_sortie:string ;
        JJcomete,JJtremplin,duree :real;
        paramT:tabparam;
        rayon_helio_sortie:vecteur;
        ch:char;
        date_calendaire:string;
  BEGIN

       DATE_SORTIE_SPHERE(date_survol_tremplin_terre,heure_survol_terre,date_sortie,heure_sortie);

       ephemterre(date_sortie,heure_sortie,mus,0,paramT,rayon_helio_sortie,vitesse_helio_sortie);

       { Normalement,
        aprs le tremplin, on devrait rejoindre la comte. Ce ne peut jamais tre vraiment le cas.
       Donc on calcule par Lambert la trajectoire qui  partir de la position terre au sortir de la sphre
       d'influenceva permettre de rejoindre la comte
    	   Date du tremplin :JJtemplin
           Date de survol comte :JJcomete
           Dure : JJcomete - JJtremplin }

           JJtremplin:=JourJulien(date_sortie,heure_sortie);
           JJcomete:=  JourJulien('02012004','120000');
           duree:= JJcomete - JJtremplin;


  WriteLn('   ************************** LIRE ATTENTIVEMENT ***************************');
  WriteLn;
  WriteLn('   A ce niveau du calcul, le programme a besoin d''utiliser, ce qui est rare,');
  WriteLn('   un voyage de  LAMBERT entre la Terre depuis la position aprs le tremplin,');
  WriteLn('   jusqu'' la position de la Comete WILD-2, mais en faisant un tour de plus ');
  WriteLn('   avant de rejoindre la comte.');
  WriteLn('   Dans ces conditions, il y a 2 solutions possibles et le choix ne peut pas ');
  WriteLn('   tre ralis dans le programme.');
  WriteLn;
  WriteLn('   Il faut donc faire une pause dans ce programme, et lancer LAMBERTC.EXE ');
  WriteLn('   en fournissant les positions Comte et Terre ');
  WriteLn ;

  If choix=1 then
  Begin
        WriteLn('     NB : Le tir du 6 fvrier 1999, avec tremplin le 15 janvier 2001 est ');
        WriteLn('     prprogramm et fournit au programme toutes les donnes ncessaires:');
        WriteLn;
        WriteLn('     Ci-dessous les coordonnes de la comte le 2 janvier 2004');
        WriteLn;
  	WriteLn('        rayon_comete[1]:=-171.47365e6 km');
  	WriteLn('        rayon_comete[2]:=-218.18235e6 km');
  	WriteLn('        rayon_comete[3]:=15.63268e6 km');
  	WriteLn;
        WriteLn('    *********** APPUYEZ SUR UNE TOUCHE POUR CONTINUER ***********');
       	WriteLn;ch:=readkey;
 	WriteLn('    Dure du voyage calcule pour mmoire :');
  	WriteLn('          DUREE =',duree:10:5,' Jours Juliens');
  	WriteLn;
  	WriteLn('    On fournit aussi la position Terre le 15 janvier 2001:');
  	WriteLn;
	WriteLn('        rayon_Terre[1]:=',rayon_helio_sortie[1],' km');
  	WriteLn('        rayon_Terre[2]:=',rayon_helio_sortie[2],' km');
  	WriteLn('        rayon_Terre[3]:=',rayon_helio_sortie[3],' km');
  	WriteLn;
        date_calendaire:=DateSimple(JourJulien(datetir0,heureTir0));
        WriteLn('     Pour le Tir du ', date_calendaire,' le programme calcule et fournit les composantes');
        WriteLn('     de la vitesse hliocentrique ncessaire de dpart vers WILD2 par LAMBERT, pour mmoire :');
        WriteLn;
        WriteLn('     vitesse_helio_depart[1]=-32.5973 km/s');
        WriteLn('     vitesse_helio_depart[2]=-16.0289 km/s');
        WriteLn('     vitesse_helio_depart[3]=2.2461 km/s');

        { Donnes ncessaires au programme provenant de LAMBERTC}

        vitesse_helio_depart[1]:=-32.5973;
        vitesse_helio_depart[2]:=-16.0289;
        vitesse_helio_depart[3]:=2.2461;
  end;

  If choix>1 then
    Begin
        WriteLn('    DUREE DU VOYAGE calcule par le programme  :');
        WriteLn;
  	WriteLn('          DUREE =',duree:10:5,' Jours Juliens');
  	WriteLn;

        { COORDONNEES DU POINT D'ARRIVEE }

        WriteLn;
        WriteLn('     Ci-dessous les coordonnes de la comte le 2 janvier 2004');
        WriteLn;
  	WriteLn('        rayon_comete[1]:=-171.47365e6 km');
  	WriteLn('        rayon_comete[2]:=-218.18235e6 km');
  	WriteLn('        rayon_comete[3]:=15.63268e6 km');
  	WriteLn;

        { COORDONNEES DU POINT DE DEPART ( Terre au moment de la sortie sphre d'influence) }

        WriteLn('     COORDONNEES HELIOCENTRIQUES DE LA TERRE le :',date_sortie,' : ',heure_sortie);
        WriteLn;
      	WriteLn('        rayon_Terre[1]:=',rayon_helio_sortie[1],' km');
  	WriteLn('        rayon_Terre[2]:=',rayon_helio_sortie[2],' km');
  	WriteLn('        rayon_Terre[3]:=',rayon_helio_sortie[3],' km');
        WriteLn;
        WriteLn('    FAITES LE CHOIX DE L''ORBITE DE PERIODE PROCHE DE 2 ANS ');
        WriteLn;
  	WriteLn('    Le rsultat intressant  noter est celui de la vitesse sonde au dpart');

        date_calendaire:=DateSimple(JourJulien(datetir0,heureTir0));

        WriteLn('     Pour le tir de Lambert du ',date_calendaire);
        WriteLn('     Les composantes de la vitesse hliocentrique au dpart sont ncessaires');
        WriteLn;
        Write('    Donnez ses composantes: V(1))= ');readLn(vitesse_helio_depart[1]);
  	Write('                            V(2))= ');readLn(vitesse_helio_depart[2]);
  	Write('                            V(3))= ');readLn(vitesse_helio_depart[3]);

    end;

   WriteLn;
   WriteLn('    *********** APPUYEZ SUR UNE TOUCHE UNE FOIS LE RESULTAT DONNE ***********');
   WriteLn('                          !!!!! PATIENTEZ LE CALCUL EST LONG ');
   WriteLn;
   ch:=readkey;

 END;


 { --------------------------------------------------------------------------------------------------------}
 PROCEDURE ITERATION_SUR_PSI(Var vitesse_helio_sortie:vecteur;Var altitude_survol_tremplin,
                        DV_min,PSI_MIN:real;Var DELTAV_MIN_CORRECTION,Vit_inf_sortie_min:vecteur );


 Var result,vitesse_obtenue,Delta_V_Correction,rayon_terre,vitesse_sonde_obtenue:vecteur;
     duree,JJdatetir,traversee,Delta_V_Correction_init, DELTAV_MIN,Delta_V:real;
     paramT:tabparam;
     date_sortie,heure_sortie:string;
     ch:char;


 BEGIN

    traversee:=Rayon_sphere/norm(vit_infinie_arrivee_terre);
    JJdateTir:=JourJulien('15012001','120000');  { Date julienne du tir  l'injection hyperbolique }
    JJdateTir:=JJdatetir+Traversee/86400;       { Date julienne de sortie sphre d'influence}
    Date_sortie:=DateSimple(JJdateTir);               { Date 'STRING' de sortie sphre d'influence}
    Heure_sortie:=HeureSimple(JJdateTir);

    ephemterre(date_sortie,heure_sortie,mus,0,paramT,rayon_terre,vitesse_helio_sortie);

    {INITIALISATIONS AU CAS OU LA BOUCLE WHILE  RESTE NEGATIVE }

    DeltaV_MIN_CORRECTION[1]:=100;
    DeltaV_MIN_CORRECTION[2]:=100;
    DeltaV_MIN_CORRECTION[3]:=100;
    DV_min:=100;
    PSI_MIN:=0;
    vitesse_sonde_obtenue[1]:=100;
    vitesse_sonde_obtenue[2]:=100;
    vitesse_sonde_obtenue[3]:=100;

    Delta_V_Correction_init:=30;
    psi:=0;

    While psi<=2*pi  do
       BEGIN
          VITESSE_INFINIE_SORTIE_TREMPLIN(psi,altitude_survol_tremplin,vit_infinie_arrivee_terre,vit_infinie_sortie);

        { CALCUL DE LA CORRECTION DE TRAJECTOIRE POUR OBTENIR LA VITESSE HELIOCENTRIQUE SORTIE SPHERE ADEQUATE) }

          somme(vitesse_helio_sortie,vit_infinie_sortie,vitesse_obtenue);

          scalvect(-1,vitesse_obtenue,result);

          somme(vitesse_helio_depart ,result,Delta_V_Correction);

          { Initialisation DeltaV_MIN_CORRECTION qui est la meilleure correction vectorielle }


           Delta_V:=norm(Delta_V_Correction);
           If Delta_V<=Delta_V_Correction_init then
             BEGIN

                 DV_min:=Delta_V;
                 PSI_MIN:=psi;
                 Delta_V_Correction_init:=Delta_V;
                 vitesse_sonde_obtenue:= vitesse_obtenue; { Vitesse STARDUST aprs correction}
                 Scalvect(1,Delta_V_Correction,DeltaV_MIN_CORRECTION);
                 Vit_inf_sortie_min:=vit_infinie_sortie;  { Mmorisation de la vitesse infinie de sortie}
              END;

          psi:=psi+pi/360;

     END;

     If autorisation_ecriture then  { ECRITURE UNIQUEMENT HORS DE LA BOUCLE OPIMISATION FINALE}
        Begin

           WriteLn('     ***  VITESSE HELIOCENTRIQUE REQUISE POUR REJOINDRE WILD2 ***');WriteLn;
      	   WriteLn('     Vitesse heliocentrique depart(1)=',Vitesse_helio_depart[1]:7:3,' km/s');
     	   WriteLn('     Vitesse heliocentrique depart(2)=',Vitesse_helio_depart[2]:7:3,' km/s');
      	   WriteLn('     Vitesse heliocentrique depart(3)=',Vitesse_helio_depart[3]:7:3,' km/s');
      	   WriteLn;
           WriteLn('     ***  VITESSE HELIOCENTRIQUE DE LA TERRE EN FIN DE TREMPLIN ***');WriteLn;
      	   WriteLn('     Vitesse heliocentrique Terre en sortie de tremplin(1)=',Vitesse_helio_sortie[1]:7:3,' km/s');
      	   WriteLn('     Vitesse heliocentrique Terre en sortie de tremplin(2)=',Vitesse_helio_sortie[2]:7:3,' km/s');
      	   WriteLn('     Vitesse heliocentrique Terre en sortie de tremplin(3)=',Vitesse_helio_sortie[3]:7:3,' km/s');
           WriteLn;

           WriteLn('     ***  VITESSE HELIOCENTRIQUE DE STAR DUST EN SORTIE DE TREMPLIN ***');WriteLn;
           WriteLn('     Vitesse injection obtenue(1)=',vitesse_sonde_obtenue[1]:7:3,' km/s');
           WriteLn('     Vitesse injection obtenue(2)=',vitesse_sonde_obtenue[2]:7:3,' km/s');
           WriteLn('     Vitesse injection obtenue(3)=',vitesse_sonde_obtenue[3]:7:3,' km/s');
           WriteLn;
           WriteLn(' ???? Notez vos rsultats avant de passer  la suite, puis appuyez une touche');
           ch:=readkey;


           VITESSE_INFINIE_SORTIE_TREMPLIN(PSI_MIN,altitude_survol_tremplin,vit_infinie_arrivee_terre,
                                          Vit_Inf_Sortie_Min);


           WriteLn('     ***  VITESSE INFINIE EN SORTIE DE TREMPLIN POUR PSI= ',(PSI_MIN*180/pi):7:3,'  ***');
           WriteLn;
           WriteLn('     Vit_infinie_sortie(1)=',Vit_inf_sortie_min[1]:7:3,' km/s');
           WriteLn('     Vit_infinie_sortie(2)=',Vit_inf_sortie_min[2]:7:3,' km/s');
           WriteLn('     Vit_infinie_sortie(3)=',Vit_inf_sortie_min[3]:7:3,' km/s');
           WriteLn;

           WriteLn('     ***  CORRECTION MINIMALE EN SORTIE DE TREMPLIN POUR PSI= ',(PSI_MIN*180/pi):7:2,'  ***');
           WriteLn;
           WriteLn('     DeltaV_MIN_CORRECTION(1)=',DeltaV_MIN_CORRECTION[1]:7:3,' km/s');
           WriteLn('     DeltaV_MIN_CORRECTION(2)=',DeltaV_MIN_CORRECTION[2]:7:3,' km/s');
           WriteLn('     DeltaV_MIN_CORRECTION(3)=',DeltaV_MIN_CORRECTION[3]:7:3,' km/s');
           WriteLn;

           WriteLn('     DELTAV_MIN =',DV_MIN:3:3,' km/s ', ' Pour psi = ',(PSI_MIN*180/pi):7:2,' degrs',
                   '  A : ',altitude_survol_tremplin:5:0, ' km'); writeLn;
        end;

 END;




 { ------------------------------------------------------------------------------------------------------}
  PROCEDURE ALTITUDE_SURVOL_OPTIMAL(Var DV_OPTIMAL:vecteur);

  Var result,vitesse_sonde_obtenue:vecteur;

  BEGIN

  { Initialisations larges }
     autorisation_ecriture:=false;
     DVMIN_MIN:=100;
     PSIMIN_MIN:=0;
     DV_OPTIMAL[1]:=100;
     DV_OPTIMAL[2]:=100;
     DV_OPTIMAL[3]:=100;

     For i:=0 to 100 do
       BEGIN
          altitude_survol_tremplin:=4000+125*i;
          ITERATION_SUR_PSI(vitesse_helio_sortie,altitude_survol_tremplin,DV_min,PSI_MIN,
                            DeltaV_MIN_CORRECTION,Vit_Inf_Sortie_Min );

          If DV_min<=DVMIN_MIN then
              BEGIN
                DVMIN_MIN:=DV_min;
                Altitude_optimale:= altitude_survol_tremplin;
                PSIMIN_MIN:=PSI_MIN;
                somme(Vit_Inf_Sortie_Min,vitesse_helio_sortie,vitesse_sonde_obtenue);
                {scalvect(-1,vitesse_sonde_obtenue,result);
                somme(result,vitesse_helio_depart,DV_OPTIMAL);}
                DV_OPTIMAL:=DeltaV_MIN_CORRECTION;

               END;
           If i=100 then autorisation_ecriture:=true;

           END;

    ITERATION_SUR_PSI(vitesse_helio_sortie,altitude_optimale,DV_min,PSI_MIN,DeltaV_MIN_CORRECTION,Vit_Inf_Sortie_Min );

    WriteLn('     OPTIMUM:* ALTITUDE=', Altitude_optimale:5:0,' KM',' * DV MINI = ',
                             DVMIN_MIN:6:3,' KM/S ',' * PSI= ',(PSIMIN_MIN*180/pi):7:3,' Degrs');
    WriteLn;
    WriteLn('     *****  COMPOSANTES DE LA VITESSE INFINIE DE SORTIE DE TREMPLIN  *****');
    WriteLn;
    WriteLn('    Vitesse infinie sortie[1]= ',Vit_inf_sortie_min[1]:7:3,' KM/S');
    WriteLn('    Vitesse infinie sortie[2]= ',Vit_inf_sortie_min[2]:7:3,' KM/S  DE NORME =',Norm(Vit_Inf_Sortie_Min):7:3,
            ' KM/S');
    WriteLn('    Vitesse infinie sortie[2]= ',Vit_inf_sortie_min[3]:7:3,' KM/S');
    WriteLn;

    WriteLn('     *****  COMPOSANTES DE L''INCREMENT DE CORRECTION  *****');
    WriteLn;
    WriteLn('     DeltaV_MIN_CORRECTION[1]= ', DeltaV_MIN_CORRECTION[1]:7:3,' KM/S');
    WriteLn('     DeltaV_MIN_CORRECTION[2]= ', DeltaV_MIN_CORRECTION[2]:7:3,' KM/S  DE NORME =',
                  Norm(DeltaV_MIN_CORRECTION):7:3,' KM/S');
    WriteLn('     DeltaV_MIN_CORRECTION[3]= ', DeltaV_MIN_CORRECTION[3]:7:3,' KM/S');


  END;


{ ****************************************** PROGRAMME PRINCIPAL ******************************************}

BEGIN

  DONNEES_MISSION(Choix);
  ORBITE0_AVANT_CORRECTION;
  { -------------- PREMIER PASSAGE EN OUBLIANT LA SPHERE D'INFLUENCE DE LA TERRE --------------------}
  OPTIMISATION_CORRECTION;
  ORBITE_AVANT_TREMPLIN(Rayon_helio_correction,Vitesse_helio_correction,Date_calcul_correction,PARAM1);
  VITESSE_INFINIE_ARRIVEE(Param1,date_survol_tremplin_terre,heure_survol_terre,
                 vit_infinie_arrivee_terre,C3_T_ARRIVEE);


  { NECESSAIRE POUR PERMETTRE LE CHOIX ENTRE LES 2 ORBITES, SAUF POUR LE TIR DU 6 fvrier 1999 et tremplin du 15/1/2001}

  LAMBERT_INTERMEDIAIRE(vitesse_helio_depart);
              { RESULTATS PARTIELLEMENT OPTIMISES SUR PSI, MAIS AVEC L'ALTITUDE INITIALE CHOISIE }
  ITERATION_SUR_PSI(vitesse_helio_sortie,altitude_survol_tremplin,DV_min,PSI_MIN,DeltaV_MIN_CORRECTION,Vit_Inf_Sortie_Min );

  VITESSE_INFINIE_SORTIE_TREMPLIN(PSI_MIN,altitude_survol_tremplin,vit_infinie_arrivee_terre,
                                       vit_infinie_sortie);


  {WriteLn('     MINIMUM DV = ', (DV_min*1000):6:1,' m/s ',' POUR UN ANGLE PSI = ',
              (PSI_MIN*180/pi):7:3,' degrs', ' SURVOL SOL(CHOISI AU DEPART) A ',altitude_survol_tremplin:6:0, ' KM'); }

  WriteLn('     UN BALAYAGE EN ALTITUDE DONNERA L''ALTITUDE OPTIMALE DU TREMPLIN'); WriteLn;
  ch:=readkey;
  autorisation_ecriture:=false;
  ALTITUDE_SURVOL_OPTIMAL(DV_OPTIMAL);

                           {  SYNTHESE REDONDANTE POUR VERIFICATION }

  autorisation_ecriture:=true;

  ITERATION_SUR_PSI(vitesse_helio_sortie,Altitude_optimale,DV_min,PSI_MIN,DeltaV_MIN_CORRECTION,Vit_Inf_Sortie_Min );

  WriteLn;
  WriteLn('            Altitude optimale pour le tremplin = ', Altitude_optimale:6:0,' km');
  { -----------------------------------------------------------------------------------------------------}

  { ***********  ARRET PAR  UNE TOUCHE ............ ET FIN DU PROGRAMME   ***********}

  ch:=readkey;DoneWinCrt;


 END.
